/*
 * File         : SOCK_Stream.h
 * Author       : Tomasz Stachowiak
 * Created      : Tue May 19 20:12:47 1998
 * Revision     : $Revision$
 * Updated      : $Date$
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

#ifndef __SOCK_STREAM_H
#define __SOCK_STREAM_H

#include <BVN/BVN.h>
#include <BVN/SAP.h>

#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

class SOCK_Stream
{
 public:

  void set_handle(HANDLE handle);
  int close(void);
  int recv_n( void* buffer, int len );
  int send_n( void* buffer, int len ) const;
  HANDLE get_handle( void ) const;
  int set_peer_address(struct sockaddr_in *addr);
  int get_peer_address(struct sockaddr_in *addr);
  

 private:

  SAP sap;
  struct sockaddr_in peer_addr_;

};



#endif

